#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
using namespace std;
typedef long long int64;
typedef unsigned long long uint64;
const int mod=900000011;
const int maxSub=25;
 
#define myrand() (rand()|(rand()<<16))
#define myrand64() (myrand()|(int64(myrand())<<32))
 
int expmod(int a,int b) {
	int ans=1;
	for(;b;b>>=1) {
		if(b&1)
		    ans=(int64)ans*a%mod;
        a=(int64)a*a%mod;
	}
	return ans;
}
struct uint128 {
	unsigned val[4];
};
int cmp(const uint128 &a,const uint128 &b) {
	for(int i=3;i>=0;i--)
	    if(a.val[i]>b.val[i])
	        return +1;
		else if(a.val[i]<b.val[i])
	        return -1;
	return 0;
}
void muladd(uint64 a,uint64 b,uint64 c,uint128 &ans) {
	const int64 mask=0xffffffffU;
    uint64 sA=(a&mask)*(b&mask);
	uint64 sB1=(a&mask)*(b>>32);
	uint64 sB2=(a>>32)*(b&mask);
	uint64 sC=(a>>32)*(b>>32);
 
	uint64 A=(c&mask)+(sA&mask);
	uint64 B=(c>>32)+(sA>>32)+(sB1&mask)+(sB2&mask);
	uint64 C=(sC&mask)+(sB1>>32)+(sB2>>32);
	uint64 D=sC>>32;
 
	B+=A>>32;
	C+=B>>32;
	D+=C>>32;
 
	ans.val[0]=A,ans.val[1]=B,ans.val[2]=C,ans.val[3]=D;
}
uint64 muldiv(uint64 A,uint64 B,uint64 C,uint64 D) {
    uint128 v1,v2;
    muladd(A,B,C,v1);
    
    uint64 cur=0;
	for(int i=63;i>=0;i--) {
		muladd(D,cur+(1ULL<<i),0,v2);
		if(cmp(v1,v2)>=0)
		    cur+=1ULL<<i;
	}
	return cur;
}
int rev[maxSub+5];
int comb[maxSub+5][maxSub+5];
int poly[maxSub+5][maxSub+5];
int polyComb[maxSub+5][maxSub+5];
void init() {
    for(int i=1;i<=maxSub+1;i++)
        rev[i]=expmod(i,mod-2);
 
	for(int i=0;i<=maxSub+1;i++) {
		comb[i][0]=1;
		for(int j=1;j<=i;j++)
		    if((comb[i][j]=comb[i-1][j]+comb[i-1][j-1])>mod)
		        comb[i][j]-=mod;
	}
	for(int i=0;i<=maxSub;i++) {
		poly[i][i+1]=1;
		for(int j=0;j<i;j++) {
            int coef=comb[i+1][j];
            if((i-j)&1)
                coef=-coef;
			for(int k=0;k<=j+1;k++)
			    if((poly[i][k]=(poly[i][k]-(int64)coef*poly[j][k])%mod)<0)
			        poly[i][k]+=mod;
		}
		for(int j=0;j<=i+1;j++)
		    poly[i][j]=(int64)poly[i][j]*expmod(i+1,mod-2)%mod;
	}
 
	polyComb[0][0]=1;
	for(int i=1;i<=maxSub;i++)
		for(int j=1;j<=i;j++)
		    polyComb[i][j]=(int64(i-1)*polyComb[i-1][j]+polyComb[i-1][j-1])%mod;
 
    for(int i=1;i<=maxSub;i++) {
		int fac=1;
		for(int j=1;j<=i;j++)
		    fac=(int64)fac*j%mod;
		fac=expmod(fac,mod-2);
 
        for(int j=i;j>=0;j--) {
            if(((i-j)&1)&&polyComb[i][j])
                polyComb[i][j]=mod-polyComb[i][j];
			polyComb[i][j]=(int64)polyComb[i][j]*fac%mod;
		}
	}
}
int calcPoly(int val,int n) {
    int pow=1,ans=0;
	for(int i=0;i<=n+1;i++) {
        ans=(ans+(int64)poly[n][i]*pow)%mod;
        pow=(int64)pow*val%mod;
	}
	return ans;
}
int sub;
int dp[2][maxSub+5][maxSub+5],pos;
void solve(int64 N,int64 A,int64 B,int64 C) {
	//printf("%lld %lld %lld %lld\n",N,A,B,C);
	if(N<=0) {
		pos=0;
		memset(dp[pos],0,sizeof(dp[pos]));
		return;
	}
	if(A==0) {
        pos=0;
		for(int n=0;n<=sub;n++) {
			int val1=calcPoly(N%mod,n),val2=B/C%mod;
			for(int m=0;n+m<=sub;m++) {
			    dp[pos][n][m]=val1;
			    val1=(int64)val1*val2%mod;
			}
		}
		return;
	}
	
	if(A<C&&B<C) {
		int64 div=muldiv(A,N,B,C);
		//int64 div=(A*N+B)/C;
        if(div==0) {
	        pos=0;
	        memset(dp[pos],0,sizeof(dp[pos]));
			for(int n=0;n<=sub;n++)
				dp[pos][n][0]=calcPoly(N%mod,n);
 
 
		    return;
		}
 
        solve(div-1,C,C-B-1,A),pos^=1;
//memset(dp[pos],0,sizeof(dp[pos]));return;
		static int coefM[maxSub+5][maxSub+5];
		static int coefN[maxSub+5][maxSub+5];
		memset(coefM,0,sizeof(coefM));
		memset(coefN,0,sizeof(coefN));
		for(int n=0;n<=sub;n++)
		for(int nn=0;nn<=n+1;nn++)
			coefN[n][nn]=poly[n][nn];
	    for(int m=0;m<=sub;m++)
		for(int mm=0;mm<=m-1;mm++)
			coefM[m][mm]=comb[m][mm];
 
        static int tmp[maxSub+5][maxSub+5];
        for(int m=0;m<=sub;m++)
        for(int nn=0;nn<=sub;nn++) {
			int64 ans=0;
            for(int mm=0;nn+mm<=sub;mm++) {
                ans+=(int64)coefM[m][mm]*dp[pos^1][mm][nn];
                if(ans>8000000000000000000LL)
                    ans%=mod;
			}
			tmp[m][nn]=ans%mod;
		}
		for(int n=0;n<=sub;n++) {
			int val1=calcPoly(N%mod,n),val2=calcPoly((C-B-1)/A%mod,n),val3=div%mod;
			for(int m=0;n+m<=sub;m++) {
				int ans=val1;
				val1=(int64)val1*val3%mod;
				if(m&&(ans-=val2)<0)
				    ans+=mod;
 
				int64 tot=0;
				for(int nn=0;nn<=sub;nn++) {
					tot+=(int64)tmp[m][nn]*coefN[n][nn];
					if(tot>8000000000000000000LL)
                    	tot%=mod;
				}
				ans=(ans-tot)%mod;
				if(ans<0)
				    ans+=mod;
 
				dp[pos][n][m]=ans;
			}
		}
	} else {
        solve(N,A%C,B%C,C),pos^=1;
//memset(dp[pos],0,sizeof(dp[pos]));return;
        static int tmp2[maxSub+5][maxSub+5];
        for(int m=0;m<=sub;m++) {
			int val1=(m+1)*(B/C%mod)%mod;
        	for(int gi=0;gi<=m;gi++)
            	tmp2[m][gi]=rev[m-gi+1]*int64(val1)%mod;
		}
            
 
 
		for(int n=0;n<=sub;n++) {
	        static int group[maxSub+5];
	        memset(group,0,sizeof(group));
	        int val1=1,val2=A/C%mod;
			for(int i=0;n+i<=sub;i++) {
				for(int j=0;n+i+j<=sub;j++)
			    	group[i+j]=(group[i+j]+(int64)val1*comb[i+j][i]%mod*dp[pos^1][i+n][j])%mod;
				val1=(int64)val1*val2%mod;
			}
 
			for(int m=0;m+n<=sub;m++) {
				int ans=0;
				for(int gi=0;gi<=m;gi++)
				    if((ans+=group[gi])>=mod)
				        ans-=mod;
 
	            dp[pos][n][m]=ans;
 
				for(int gi=0;gi<=m;gi++)
				    //group[gi]=(int64)group[gi]*expmod(m-gi+1,mod-2)%mod*(m+1)%mod*(B/C%mod)%mod;
				    group[gi]=(int64)group[gi]*tmp2[m][gi]%mod;
			}
		}
	}
}
int answer(int64 N,int64 A,int64 B,int n,int m) {
	m++;
 
	sub=n+m,solve(N,A,0,B);
 
	static int coefN[maxSub+5];
	static int coefM[maxSub+5];
	for(int j=0;j<=n;j++) {
		int val=0;
		for(int i=j;i<=n;i++)
	    	val=(val+(int64)polyComb[n][i]*comb[i][j]%mod*expmod(N%mod,i-j))%mod;
 
		if((j&1)&&val)
		    val=mod-val;
        coefN[j]=val;
	}
	for(int j=0;j<=m;j++) {
		int val=0;
		for(int i=j;i<=m;i++)
	    	val=(val+(int64)polyComb[m][i]*comb[i][j])%mod;
 
        coefM[j]=val;
	}
	if(m==1)
	    coefM[0]--;
 
	int ans=0;
	for(int i=0;i<=n;i++)
	for(int j=0;j<=m;j++)
	    ans=(ans+(int64)coefN[i]*coefM[j]%mod*dp[pos][i][j])%mod;
	return ans;
}
int main() {
	/*int64 A=1,B=1,C;
	for(int i=1;i<400;i++) {
		C=A+B,A=B,B=C;
		printf("%lld\n",C);
		if(C>1000000000000000000LL)
		    break;
	}
	scanf("%*s");*/
	init();
 
    /*int64 A=myrand64()%1000000000000000000LL+1;
    int64 B=myrand64()%1000000000000000000LL+1;
    int64 C=myrand64()%1000000000000000000LL+1;
    int64 D=myrand64()%1000000000000000000LL+1;
    uint64 V0,V1;
    unsigned pack[4];
	for(int step=0;step<1000000;step++)
	    muldiv(A,B,C,D);*/
 
	//printf("%lld\n",muldiv(50000000000LL+1,50000000000LL-1,0,100000000000LL));
	//long t=clock();
	int T=50;
	scanf("%d",&T);
 
	for(int TT=1;TT<=T;TT++) {
		int64 N,A,B;
		int n,m;
		
		N=myrand64()%1000000000000000000LL+1;
		A=420196140727489673LL;
		B=679891637638612258LL;
		//A=myrand64()%1000000000000000000LL+1;
		//B=myrand64()%1000000000000000000LL+1;
		n=10;
		m=10;
 
		scanf("%lld%lld%lld%d%d",&N,&A,&B,&m,&n);printf("%d\n",answer(N,A,B,n,m));
		//answer(N,A,B,n,m);
	}
	//printf("[%ld]",clock()-t);
	scanf("%*s");
}
 